From 91572e06dffc954a666937e3078fc15e76b08e8a Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Tue, 2 Sep 2014 19:46:10 +0200
Subject: [PATCH 2/3] vmmemctl VMware Player 6.0.3 build-1895310

---
 sys/conf/files                                     |    2 +
 sys/dev/virtual/vmware/shared/backdoor_def.h       |   27 +-
 sys/dev/virtual/vmware/shared/circList.h           |    2 +-
 sys/dev/virtual/vmware/shared/includeCheck.h       |   13 +-
 sys/dev/virtual/vmware/shared/vm_assert.h          |  210 +--
 sys/dev/virtual/vmware/shared/vm_atomic.h          |  415 ++++--
 sys/dev/virtual/vmware/shared/vm_basic_asm.h       |  342 ++++-
 sys/dev/virtual/vmware/shared/vm_basic_asm_x86.h   |   18 +
 .../virtual/vmware/shared/vm_basic_asm_x86_64.h    |   21 +-
 sys/dev/virtual/vmware/shared/vm_basic_defs.h      |   85 +-
 sys/dev/virtual/vmware/shared/vm_basic_math.h      |   18 +
 sys/dev/virtual/vmware/shared/vm_basic_types.h     |   79 +-
 sys/dev/virtual/vmware/shared/vm_device_version.h  |   39 +-
 sys/dev/virtual/vmware/shared/x86cpuid.h           | 1369 ++++++++++++--------
 sys/dev/virtual/vmware/shared/x86cpuid_asm.h       |    4 +-
 sys/gnu/dev/virtual/vmware/vmmemctl/Makefile       |    2 +-
 .../dev/virtual/vmware/vmmemctl/backdoorGcc64.c    |    2 +-
 .../dev/virtual/vmware/vmmemctl/backdoor_balloon.c |  362 ++++++
 .../dev/virtual/vmware/vmmemctl/backdoor_balloon.h |   14 +-
 sys/gnu/dev/virtual/vmware/vmmemctl/balloonInt.h   |   75 ++
 sys/gnu/dev/virtual/vmware/vmmemctl/balloon_def.h  |  186 ++-
 sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubs.h  |   89 ++
 .../dev/virtual/vmware/vmmemctl/kernelStubsBSD.c   |  259 ++++
 sys/gnu/dev/virtual/vmware/vmmemctl/os.c           |  119 +-
 sys/gnu/dev/virtual/vmware/vmmemctl/os.h           |    9 +-
 sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.c    |  893 ++++++-------
 sys/gnu/dev/virtual/vmware/vmmemctl/vmballoon.h    |   75 +-
 27 files changed, 3487 insertions(+), 1242 deletions(-)
 create mode 100644 sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.c
 create mode 100644 sys/gnu/dev/virtual/vmware/vmmemctl/balloonInt.h
 create mode 100644 sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubs.h
 create mode 100644 sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubsBSD.c

diff --git a/sys/conf/files b/sys/conf/files
index 432c176..7c72581 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -877,6 +877,8 @@ dev/virtual/vmware/vmblock/stubs.c	optional vmblock
 dev/virtual/vmware/vmblock/subr.c	optional vmblock
 dev/virtual/vmware/vmblock/vnops.c	optional vmblock
 dev/virtual/vmware/vmblock/vfsops.c	optional vmblock
+gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.c optional vmmemctl
+gnu/dev/virtual/vmware/vmmemctl/kernelStubsBSD.c optional vmmemctl
 gnu/dev/virtual/vmware/vmmemctl/os.c	optional vmmemctl
 gnu/dev/virtual/vmware/vmmemctl/vmballoon.c optional vmmemctl
 gnu/vfs/ext2fs/ext2_alloc.c		optional ext2fs
diff --git a/sys/dev/virtual/vmware/shared/backdoor_def.h b/sys/dev/virtual/vmware/shared/backdoor_def.h
index 807d2f2..bf7d480 100644
--- a/sys/dev/virtual/vmware/shared/backdoor_def.h
+++ b/sys/dev/virtual/vmware/shared/backdoor_def.h
@@ -139,6 +139,9 @@
 #  define BDOOR_CMD_FAS_GET_TABLE_DATA        1
 #  define BDOOR_CMD_FAS_GET_PLATFORM_NAME     2
 #  define BDOOR_CMD_FAS_GET_PCIE_OSC_MASK     3
+#  define BDOOR_CMD_FAS_GET_APIC_ROUTING      4
+#  define BDOOR_CMD_FAS_GET_TABLE_SKIP        5
+#  define BDOOR_CMD_FAS_GET_SLEEP_ENABLES     6
 #define   BDOOR_CMD_SENDPSHAREHINTS          66
 #define   BDOOR_CMD_ENABLE_USB_MOUSE         67
 #define   BDOOR_CMD_GET_VCPU_INFO            68
@@ -151,7 +154,19 @@
 #define   BDOOR_CMD_FIRMWARE_ERROR           71 /* CPL 0 only. */
 #  define BDOOR_CMD_FE_INSUFFICIENT_MEM       0
 #  define BDOOR_CMD_FE_EXCEPTION              1
-#define   BDOOR_CMD_MAX                      72
+#define   BDOOR_CMD_VMK_INFO                 72
+#define   BDOOR_CMD_EFI_BOOT_CONFIG          73 /* CPL 0 only. */
+#  define BDOOR_CMD_EBC_LEGACYBOOT_ENABLED    0
+#  define BDOOR_CMD_EBC_GET_ORDER             1
+#  define BDOOR_CMD_EBC_SHELL_ACTIVE          2
+#define   BDOOR_CMD_GET_HW_MODEL             74 /* CPL 0 only. */
+#define   BDOOR_CMD_GET_SVGA_CAPABILITIES    75 /* CPL 0 only. */
+#define	  BDOOR_CMD_GET_FORCE_X2APIC         76 /* CPL 0 only  */
+#define   BDOOR_CMD_SET_PCI_HOLE             77 /* CPL 0 only  */
+#define   BDOOR_CMD_GET_PCI_HOLE             78 /* CPL 0 only  */
+#define   BDOOR_CMD_GET_PCI_BAR              79 /* CPL 0 only  */
+#define   BDOOR_CMD_SHOULD_GENERATE_SYSTEMID 80 /* CPL 0 only  */
+#define   BDOOR_CMD_MAX                      81
 
 
 /*
@@ -174,8 +189,9 @@
 /* Task applied to backdoor pshare hints */
 #define BDOOR_PSHARE_HINTS_CMD_SHARE   0
 #define BDOOR_PSHARE_HINTS_CMD_DROP    1
+#define BDOOR_PSHARE_HINTS_CMD_MAX     2
 
-#define BDOOR_PSHARE_HINTS_CMD(ecx)   (((ecx) >> 24) & 0x1)
+#define BDOOR_PSHARE_HINTS_CMD(ecx)   (((ecx) >> 24) & 0xff)
 
 /* Nesting control operations */
 
@@ -184,6 +200,11 @@
 #define NESTING_CONTROL_QUERY             2
 #define NESTING_CONTROL_MAX               2
 
+/* EFI Boot Order options, nibble-sized. */
+#define EFI_BOOT_ORDER_TYPE_EFI           0x0
+#define EFI_BOOT_ORDER_TYPE_LEGACY        0x1
+#define EFI_BOOT_ORDER_TYPE_NONE          0xf
+
 /* High-bandwidth backdoor port. --hpreg */
 
 #define BDOORHB_PORT 0x5659
@@ -206,6 +227,8 @@
 #define IS_BDOOR_PMC(index)  (((index) | 3) == 0x10003)
 #define BDOOR_CMD(ecx)       ((ecx) & 0xffff)
 
+/* Sub commands for BDOOR_CMD_VMK_INFO */
+#define BDOOR_CMD_VMK_INFO_ENTRY   1
 
 #ifdef VMM
 /*
diff --git a/sys/dev/virtual/vmware/shared/circList.h b/sys/dev/virtual/vmware/shared/circList.h
index d6e134b..420f775 100644
--- a/sys/dev/virtual/vmware/shared/circList.h
+++ b/sys/dev/virtual/vmware/shared/circList.h
@@ -82,7 +82,7 @@ typedef struct ListItem {
  * @member: the name of the list struct within the struct.
  */
 #define LIST_CONTAINER(ptr, type, member) \
-   ((type *)((char *)(ptr) - offsetof(type, member)))
+   VMW_CONTAINER_OF(ptr, type, member)
 
 /*
  * delete item from the list
diff --git a/sys/dev/virtual/vmware/shared/includeCheck.h b/sys/dev/virtual/vmware/shared/includeCheck.h
index 6b2ee65..f4cbc9f 100644
--- a/sys/dev/virtual/vmware/shared/includeCheck.h
+++ b/sys/dev/virtual/vmware/shared/includeCheck.h
@@ -44,6 +44,7 @@
  *	INCLUDE_ALLOW_VMK_MODULE
  *      INCLUDE_ALLOW_VMKDRIVERS
  *      INCLUDE_ALLOW_VMIROM
+ *      INCLUDE_ALLOW_MKS
  *
  * Then include this file.
  *
@@ -84,13 +85,14 @@
 #undef INCLUDE_ALLOW_VMCORE
 
 #if defined VMX86_VMX && !defined VMCORE && \
-    !(defined INCLUDE_ALLOW_VMX || defined INCLUDE_ALLOW_USERLEVEL)
+    !defined INCLUDE_ALLOW_VMX && !defined INCLUDE_ALLOW_USERLEVEL && \
+    !defined INCLUDE_ALLOW_MKS
 #error "The surrounding include file is not allowed in the VMX."
 #endif
 #undef INCLUDE_ALLOW_VMX
 
 #if defined USERLEVEL && !defined VMX86_VMX && !defined VMCORE && \
-    !defined INCLUDE_ALLOW_USERLEVEL
+    !defined INCLUDE_ALLOW_USERLEVEL && !defined INCLUDE_ALLOW_MKS
 #error "The surrounding include file is not allowed at userlevel."
 #endif
 #undef INCLUDE_ALLOW_USERLEVEL
@@ -127,3 +129,10 @@
 #error "The surrounding include file is not allowed in vmirom."
 #endif
 #undef INCLUDE_ALLOW_VMIROM
+
+#if defined INCLUDE_ALLOW_MKS && \
+    !(defined LOCALMKS  || defined REMOTEMKS || \
+      defined SERVERMKS || defined CLIENTMKS)
+#error "The surrounding include file is not allowed outside of the MKS."
+#endif
+#undef INCLUDE_ALLOW_MKS
diff --git a/sys/dev/virtual/vmware/shared/vm_assert.h b/sys/dev/virtual/vmware/shared/vm_assert.h
index 6b88c7a..905e40b 100644
--- a/sys/dev/virtual/vmware/shared/vm_assert.h
+++ b/sys/dev/virtual/vmware/shared/vm_assert.h
@@ -56,38 +56,104 @@
 #include "vm_basic_types.h"
 #include "vm_basic_defs.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 /*
- * XXX old file code
+ * Some bits of vmcore are used in VMKernel code and cannot have
+ * the VMKERNEL define due to other header dependencies.
  */
-
-#ifdef FILECODEINT
-#error "Don't define FILECODEINT.  It is obsolete."
+#if defined(VMKERNEL) && !defined(VMKPANIC)
+#define VMKPANIC 1
 #endif
-#ifdef FILECODE
-#error "Don't define FILECODE.  It is obsolete."
+
+/*
+ * Internal macros, functions, and strings
+ *
+ * The monitor wants to save space at call sites, so it has specialized
+ * functions for each situation.  User level wants to save on implementation
+ * so it uses generic functions.
+ */
+
+#if !defined VMM || defined MONITOR_APP // {
+
+#if defined VMKPANIC
+
+// vmkernel Panic() function does not want a trailing newline.
+#define _ASSERT_PANIC(name) \
+           Panic(_##name##Fmt, __FILE__, __LINE__)
+#define _ASSERT_PANIC_BUG(bug, name) \
+           Panic(_##name##Fmt " bugNr=%d", __FILE__, __LINE__, bug)
+#define _ASSERT_PANIC_NORETURN(name) \
+           Panic_NoReturn(_##name##Fmt, __FILE__, __LINE__)
+
+#else /* !VMKPANIC */
+#define _ASSERT_PANIC(name) \
+           Panic(_##name##Fmt "\n", __FILE__, __LINE__)
+#define _ASSERT_PANIC_BUG(bug, name) \
+           Panic(_##name##Fmt " bugNr=%d\n", __FILE__, __LINE__, bug)
+#endif /* VMKPANIC */
+
+#ifdef VMX86_DEVEL
+#   define _ASSERT_WARNING(name) \
+           Warning(_##name##Fmt "\n", __FILE__, __LINE__)
+#else
+#   define _ASSERT_WARNING(name) \
+           Log(_##name##Fmt "\n", __FILE__, __LINE__)
 #endif
+#define AssertUnexpectedFmt _AssertUnexpectedFmt
+#endif // }
+
+
+// these don't have newline so a bug can be tacked on
+#define _AssertPanicFmt            "PANIC %s:%d"
+#define _AssertAssertFmt           "ASSERT %s:%d"
+#define _AssertNotImplementedFmt   "NOT_IMPLEMENTED %s:%d"
+#define _AssertNotReachedFmt       "NOT_REACHED %s:%d"
+#define _AssertMemAllocFmt         "MEM_ALLOC %s:%d"
+#define _AssertNotTestedFmt        "NOT_TESTED %s:%d"
+#define _AssertUnexpectedFmt       "UNEXPECTED %s:%d bugNr=%d\n"
 
 
 /*
  * Panic and log functions
  */
 
-EXTERN void Log(const char *fmt, ...) PRINTF_DECL(1, 2);
-EXTERN void Warning(const char *fmt, ...) PRINTF_DECL(1, 2);
-EXTERN NORETURN void Panic(const char *fmt, ...) PRINTF_DECL(1, 2);
+void Log(const char *fmt, ...) PRINTF_DECL(1, 2);
+void Warning(const char *fmt, ...) PRINTF_DECL(1, 2);
+#if defined VMKPANIC
+void Panic_SaveRegs(void);
+
+#ifdef VMX86_DEBUG
+void Panic_NoSave(const char *fmt, ...) PRINTF_DECL(1, 2);
+#else
+NORETURN void Panic_NoSave(const char *fmt, ...) PRINTF_DECL(1, 2);
+#endif
 
-EXTERN void LogThrottled(uint32 *count, const char *fmt, ...)
+NORETURN void Panic_NoSaveNoReturn(const char *fmt, ...)
+   PRINTF_DECL(1, 2);
+
+#define Panic(fmt...) do { \
+   Panic_SaveRegs(); \
+   Panic_NoSave(fmt); \
+} while(0)
+
+#define Panic_NoReturn(fmt...) do { \
+   Panic_SaveRegs(); \
+   Panic_NoSaveNoReturn(fmt); \
+} while(0)
+
+
+#else
+NORETURN void Panic(const char *fmt, ...) PRINTF_DECL(1, 2);
+#endif
+
+void LogThrottled(uint32 *count, const char *fmt, ...)
             PRINTF_DECL(2, 3);
-EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
+void WarningThrottled(uint32 *count, const char *fmt, ...)
             PRINTF_DECL(2, 3);
 
-/* DB family:  messages which are parsed by logfile database system */
-#define WarningDB Warning
-#define LogDB Log
-#define WarningThrottledDB WarningThrottled
-#define LogThrottledDB LogThrottled
-
 
 /*
  * Stress testing: redefine ASSERT_IFNOT() to taste
@@ -138,29 +204,33 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
 #define PANIC()        _ASSERT_PANIC(AssertPanic)
 #define PANIC_BUG(bug) _ASSERT_PANIC_BUG(bug, AssertPanic)
 
+#ifdef VMKPANIC
+#define ASSERT_OR_IN_PANIC(cond) ASSERT((cond) || Panic_IsSystemInPanic())
+#endif
+
 #define ASSERT_NOT_IMPLEMENTED(cond) \
            ASSERT_IFNOT(cond, NOT_IMPLEMENTED())
 #define ASSERT_NOT_IMPLEMENTED_BUG(bug, cond) \
            ASSERT_IFNOT(cond, NOT_IMPLEMENTED_BUG(bug))
 
+#if defined VMKPANIC && defined VMX86_DEBUG
+#define NOT_IMPLEMENTED()        _ASSERT_PANIC_NORETURN(AssertNotImplemented)
+#else
 #define NOT_IMPLEMENTED()        _ASSERT_PANIC(AssertNotImplemented)
+#endif
 #define NOT_IMPLEMENTED_BUG(bug) _ASSERT_PANIC_BUG(bug, AssertNotImplemented)
 
+#if defined VMKPANIC && defined VMX86_DEBUG
+#define NOT_REACHED()            _ASSERT_PANIC_NORETURN(AssertNotReached)
+#else
 #define NOT_REACHED()            _ASSERT_PANIC(AssertNotReached)
+#endif
 #define NOT_REACHED_BUG(bug)     _ASSERT_PANIC_BUG(bug, AssertNotReached)
 
 #define ASSERT_MEM_ALLOC(cond) \
            ASSERT_IFNOT(cond, _ASSERT_PANIC(AssertMemAlloc))
 
 #ifdef VMX86_DEVEL
-   #define ASSERT_LENGTH(real, expected) \
-              ASSERT_IFNOT((real) == (expected), \
-                 Panic(AssertLengthFmt, __FILE__, __LINE__, real, expected))
-#else
-   #define ASSERT_LENGTH(real, expected) ASSERT((real) == (expected))
-#endif
-
-#ifdef VMX86_DEVEL
    #define ASSERT_DEVEL(cond) ASSERT(cond)
 #else
    #define ASSERT_DEVEL(cond) ((void) 0)
@@ -169,8 +239,10 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
 #define ASSERT_NO_INTERRUPTS()  ASSERT(!INTERRUPTS_ENABLED())
 #define ASSERT_HAS_INTERRUPTS() ASSERT(INTERRUPTS_ENABLED())
 
+#define NOT_TESTED() _ASSERT_WARNING(AssertNotTested)
+#define ASSERT_NOT_TESTED(cond) (UNLIKELY(!(cond)) ? NOT_TESTED() : (void)0)
 #define ASSERT_LOG_UNEXPECTED(bug, cond) \
-           (UNLIKELY(!(cond)) ? LOG_UNEXPECTED(bug) : 0)
+           (UNLIKELY(!(cond)) ? LOG_UNEXPECTED(bug) : (void)0)
 #ifdef VMX86_DEVEL
    #define LOG_UNEXPECTED(bug) \
               Warning(AssertUnexpectedFmt, __FILE__, __LINE__, bug)
@@ -179,21 +251,7 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
               Log(AssertUnexpectedFmt, __FILE__, __LINE__, bug)
 #endif
 
-#define ASSERT_NOT_TESTED(cond) (UNLIKELY(!(cond)) ? NOT_TESTED() : 0)
-#ifdef VMX86_DEVEL
-   #define NOT_TESTED() Warning(AssertNotTestedFmt, __FILE__, __LINE__)
-#else
-   #define NOT_TESTED() Log(AssertNotTestedFmt, __FILE__, __LINE__)
-#endif
-
-#define NOT_TESTED_ONCE()                                               \
-   do {                                                                 \
-      static Bool alreadyPrinted = FALSE;                               \
-      if (UNLIKELY(!alreadyPrinted)) {                                  \
-	 alreadyPrinted = TRUE;                                         \
-	 NOT_TESTED();                                                  \
-      }                                                                 \
-   } while (0)
+#define NOT_TESTED_ONCE() DO_ONCE(NOT_TESTED())
 
 #define NOT_TESTED_1024()                                               \
    do {                                                                 \
@@ -202,14 +260,16 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
       count = (count + 1) & 1023;                                       \
    } while (0)
 
-#define LOG_ONCE(_s)                                                    \
-   do {                                                                 \
-      static Bool logged = FALSE;                                       \
-      if (!logged) {                                                    \
-	 Log _s;                                                        \
-         logged = TRUE;                                                 \
-      }                                                                 \
-   } while (0)
+#define LOG_ONCE(_s) DO_ONCE(Log _s)
+
+#ifdef VMX86_DEVEL
+   #define DEPRECATED(_fix) DO_ONCE(                                     \
+                               Warning("%s:%d: %s is DEPRECATED. %s\n",  \
+                                       __FILE__, __LINE__, __FUNCTION__, \
+                                       _fix))
+#else
+   #define DEPRECATED(_fix) do {} while (0)
+#endif
 
 
 /*
@@ -278,12 +338,17 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
  * The implementation uses both enum and typedef because the typedef alone is
  * insufficient; gcc allows arrays to be declared with non-constant expressions
  * (even in typedefs, where it makes no sense).
+ *
+ * NOTE: if GCC ever changes so that it ignores unused types altogether, this
+ * assert might not fire!  We explicitly mark it as unused because GCC 4.8+
+ * uses -Wunused-local-typedefs as part of -Wall, which means the typedef will
+ * generate a warning.
  */
 
 #define ASSERT_ON_COMPILE(e) \
    do { \
       enum { AssertOnCompileMisused = ((e) ? 1 : -1) }; \
-      typedef char AssertOnCompileFailed[AssertOnCompileMisused]; \
+      UNUSED_TYPE(typedef char AssertOnCompileFailed[AssertOnCompileMisused]); \
    } while (0)
 
 
@@ -308,47 +373,8 @@ EXTERN void WarningThrottled(uint32 *count, const char *fmt, ...)
       assertions \
    }
 
-
-/*
- * Internal macros, functions, and strings
- *
- * The monitor wants to save space at call sites, so it has specialized
- * functions for each situation.  User level wants to save on implementation
- * so it uses generic functions.
- */
-
-#if !defined VMM || defined MONITOR_APP // {
-
-#if defined VMKERNEL
-// vmkernel Panic() function does not want a trailing newline.
-#define _ASSERT_PANIC(name) \
-           Panic(_##name##Fmt, __FILE__, __LINE__)
-#define _ASSERT_PANIC_BUG(bug, name) \
-           Panic(_##name##Fmt " bugNr=%d", __FILE__, __LINE__, bug)
-
-#else /* !VMKERNEL */
-#define _ASSERT_PANIC(name) \
-           Panic(_##name##Fmt "\n", __FILE__, __LINE__)
-#define _ASSERT_PANIC_BUG(bug, name) \
-           Panic(_##name##Fmt " bugNr=%d\n", __FILE__, __LINE__, bug)
-#endif /* VMKERNEL */
-
-#define AssertLengthFmt     _AssertLengthFmt
-#define AssertUnexpectedFmt _AssertUnexpectedFmt
-#define AssertNotTestedFmt  _AssertNotTestedFmt
-
-#endif // }
-
-// these don't have newline so a bug can be tacked on
-#define _AssertPanicFmt            "PANIC %s:%d"
-#define _AssertAssertFmt           "ASSERT %s:%d"
-#define _AssertNotImplementedFmt   "NOT_IMPLEMENTED %s:%d"
-#define _AssertNotReachedFmt       "NOT_REACHED %s:%d"
-#define _AssertMemAllocFmt         "MEM_ALLOC %s:%d"
-
-// these are complete formats with newline
-#define _AssertLengthFmt           "LENGTH %s:%d r=%#x e=%#x\n"
-#define _AssertUnexpectedFmt       "UNEXPECTED %s:%d bugNr=%d\n"
-#define _AssertNotTestedFmt        "NOT_TESTED %s:%d\n"
+#ifdef __cplusplus
+} /* extern "C" */
+#endif
 
 #endif /* ifndef _VM_ASSERT_H_ */
